# Update beta.r
# ADDS random intercept 
# Function Inputs:
#	y  = N_k x 1 response vector 
#	X  = N_k x p design matrix
#     b2 = n_k X 1 random intercepts for lognormal compnt., class k
#	m0 = prior mean
#	prec0  = prior precision	
#	tauinv = lognormal precision for class k
#
# April 28, 2009
##################################################  

update.beta<-function(y=y[C==k],X=X[C==k,],b2,
			    m0=m0,prec0=prec0,tinv=tauinv[k]) {
   n<-length(b2)
   N<-length(y)
   ni<-N/n
   ly<-rep(0,N)
   ly[y>0]<-log(y[y>0])
   vbeta<-solve(prec0+tinv*crossprod(X[y>0,],X[y>0,]))
   mbeta<-vbeta%*%(prec0%*%m0+tinv*t(X[y>0,])%*%(ly-rep(b2,each=ni))[y>0]) 
   return(c(rmvnorm(1,mbeta,vbeta)))
}